<?php
# BUGs: ne vsechny polozky se checkuji na delku retezce!!!
# Notes:
# 	objectentries -> 
# 		entryname => mandatory:single/multiple | string => 0/1:0/1
# 		0 = is non-mandatory; 1 = is mandatory;
# 		0 = is single; 1 = is multiple;
class checkfcs {
	public $settings;
	public $data;
	public $objectarray;
	public $action;
	public $object;
	public $rccond;
	public $auto_index;
	# desc: checks for mandatory objects and returns false = ok, true = fault;
	# $objectstruct: array();
	# $objtocheck: stdClass;
	# @return: bool;
	public function checkObjectFields($objectstruct, $objtocheck) 
	{
		$retval = false;
		foreach ($objectstruct as $key => $value) 
		{
			list($is_mandatory, $type) = explode(":", $value);
			if (isset($objtocheck->{$key}) == true) 
			{
				if (count($objtocheck->{$key}) > 1 && $type == 0) 
				{
					setNoticeMsg("{$key}: more entries of type single than one were found.");
					$retval = true;
				} 
				elseif (count($objtocheck->{$key}) < 1 ) 
				{
					setNoticeMsg("{$key}: is missing, however it's mandatory.");
					$retval = true;
				}
			} 
			else 
			{
				if ($is_mandatory == 1)
				{
					setNoticeMsg("{$key}: mandatory entry not found.");
					$retval = true;
				}
			}	
		}
		return $retval;
	}
	# desc: checks whenever value is empty or not;
	# $inputval: string;
	# @return: bool;//false==not empty;true==empty;
	public function checkEmptyVal($inputval, $ikey = null) {
		if (empty($inputval)) {
			return true;
			#$this->addError("{$ikey}: prazdna hodnota.");
		} else {
			return false;
		}
	}
	# $ikey: person;
	# valid input = only chars with whitespace(s)
	# total - 256 characters
	# i.e. John Smith
	public function nameCheck($inputval, $ikey) {
		$var = preg_replace("/^\s{2}+$/", "", $inputval);
		if (preg_match("/^[A-Za-z]+[\s]{1}[A-Za-z]+$/", $var)) {
			# everything is OK
			$retval = false;
		} else {
			setNoticeMsg("{$ikey}: invalid format.");
			$retval = true;
		}
		return $retval;
	}
	# $ikey: descr;
	# valid input = only chars with whitespace(s)
	# total - 256 characters
	# i.e. John Smith
	public function charOnlyCheck($inputval, $ikey) {
		$var = preg_replace("/^\s{2}+$/", "", $inputval);
		if (preg_match("/^[A-z\s]+$/", $var)) {
			# everything is OK
			$retval = false;
		} else {
			setNoticeMsg("{$ikey}: invalid format.");
			$retval = true;
		}
		return $retval;
	}
	# $ikey: e-mail, notify, changed;
	# valid input = valid email address
	# domain - 255 max
	# user - 64 max
	# total - 320 including '@'
	# i.e. pappa.john@yahoo.com
	public function emailCheck($inputval, $ikey) {
		$strip = preg_replace("/[\s]*$/", "", $inputval);
		if (preg_match("/^[A-z0-9_\.]+@[A-z0-9\.-]+\.[A-z]{2,4}$/", $strip)) {
			if ($ikey == "changed") {
				$moddate = date("Ymd");
				$inputval = "{$inputval} {$moddate}";
			}
			$retval = false;
		} else {
			setNoticeMsg("{$ikey}: invalid format.");
			$retval = true;
		}
		return $retval;
	}
	# $ikey: phone, fax-no;
	# valid input = phone or fax number
	# total - 24 including reserve
	# i.e. +420 201 300 500
	public function phoneCheck($inputval, $ikey) {
		if (preg_match("/^[\+][1-9]/", $inputval)) {
			$stripped = preg_replace("/[\s]*/", "", $inputval);
			$stripped = preg_replace("/^\+/", "", $stripped);
			if (preg_match("/^[\d]+$/", $stripped)) {
				$retval = false;
			} else {
				setNoticeMsg("{$ikey}: invalid format.");
				$retval = true;
			}
		} else {
			setNoticeMsg("{$ikey}: invalid format.");
			$retval = true;
		}
		return $retval;
	}
	# $ikey: nic-hdl, mntner
	# $table: where to get data
	# valid input = 2 or 4 chars followed up to 5 digits, fist digit must not be 0
	# i.e. OP12345
	# note: original RIPE nic-hdl supports format like this(?) OP12345-<source>
	#				this format is not supported here!
	public function nichdlCheck($inputval, $ikey, $table = null, $column) {
		$retval = false;
		if (preg_match("/^[A-z]{2,4}/", $inputval)) {
			$stripped = preg_replace("/^[A-z]{2,4}/", "", $inputval);
			if (preg_match("/^[1-9]{0,1}([0-9]{0,4})$/", $stripped)) {
				require_once("lib/db.php");
				$db = new db();
				$sql = "SELECT COUNT(*) AS \"rowcount\" FROM {$table} WHERE \"{$column}\" = '{$inputval}';";
				$result = $db->query($sql);
				if ($result[0]->rowcount == 0) {
					$retval = false;
				} else {
					setNoticeMsg("{$ikey}: duplicate entry.");
					$retval = true;
				}
			} else {
				setNoticeMsg("{$ikey}: invalid format.");
				$retval = true;
			}
		} else {
			setNoticeMsg("{$ikey}: invalid format.");
			$retval = true;
		}
		return $retval;
	}
	# desc: if mntnet exists and given password is valid;
	# desc: $ikey: mnt-by(nic-hdl)
	# desc: valid input: nic-hdl
	# $inputval: string;
	# $ikey: string;
	# @return: bool;
	public function mntbyCheck($inputval, $ikey, $password) {
		if (preg_match('/^[A-z][A-Za-z0-9\-_]*$/', $inputval)) {
			require_once("lib/db.php");
			$db = new db();
			$rowcount = $db->query("SELECT COUNT(*) AS \"rowcount\" FROM mntner WHERE mntner = '{$inputval}';");
			if ($rowcount['rowcount'] > 0) {
				if (!is_null($password)) {
					$sqlMntCheck = "SELECT mntner, password FROM mntner WHERE mntner = '{$inputval}';";
					$resultMntCheck = $db->query($sqlMntCheck);
					if (preg_match('/^(MD5-PW \$1\$).{30}(\/)$/', $resultMntCheck['password']) == 1) {
						$passwdmd5 = "MD5-PW $1". md5($password) . "/";
						if ($resultMntCheck['password'] == $passwdmd5) {
							$retval = false;
						} else {
							// error, but we don't want to compromise how many passwords have failed.
							// we'll deal about that later champs.
							$retval = true;
						} // if password
					} else {
						setNoticeMsg("{$ikey}: unsupported auth method;");
						$retval = false;
					}
				} else {
					setNoticeMsg("{$ikey}: field 'password' not found.");
					$retval = true;
				} // if array_key_exists
			} else {
				setNoticeMsg("{$ikey}: object doesn't exist.");
				$retval = true;
			} // if rowcount = 1
		} else {
			setNoticeMsg("{$ikey}: invalid format.");
			$retval = true;
		} // if preg_match 1-9
		if ($retval == true) {
			// now it's the right time to deal with password error.
			setNoticeMsg("mnt-by: authentication has failed {$inputval}.");
		}
		return $retval;
	}
	# $ikey: whatever
	# checks if value has not exceeded max allowed lenght
	public function maxlenghtCheck($inputval, $ikey) {
		$length = strlen($inputval);
		if ($length > 128) {
			setNoticeMsg("{$ikey}: length exceeded.");
			$retval = true;
		} else {
			$retval = false;
		}
		return $retval;
	}
	# $ikey: nic-hdl
	# checks if person or role object exists
	# var: string
	public function contactCheck($inputval, $ikey) {
		if (preg_match("/^[A-z]{2,4}/", $inputval)) {
			$stripped = preg_replace("/^[A-z]{2,4}/", "", $inputval);
			if (preg_match("/^[1-9]([0-9]{1,4})$/", $stripped)) {
				$sql1 = "SELECT COUNT(*) AS \"rowcount\" FROM nichdl WHERE \"nichdl\" = '{$inputval}';";
				require_once("lib/db.php");
				$db = new db();
				$result = $db->query($sql1);
				if ($rowcount == $itemcount) {
					$retval = false;
				} else {
					setNoticeMsg("{$ikey}: object(s) doesn't exist.");
					$retval = true;
				}
			}
		} else {
			setNoticeMsg("{$ikey}: invalid format.");
			$retval = true;
		}
		return $retval;
	}
	# $ikey: autnum
	# checks: for valid autnum
	# valid input: AS12345 & 12345 > 64000
	public function asnumCheck($inputval, $ikey, $table) {
		$rowcount = -1;
		if (preg_match("/^AS[0-9]{5,5}$/", $inputval)) {
			# tuto podminku lze s klidem vynechat
			$string = substr($inputval, 2);
			# ToDo - check, jestli opravdu funguje $string < 64000
			if ((int) $string < 64000) {
				setNoticeMsg("asnum: Wrong AS number;");
				$retval = true;
			} else {
				# ToDo - DB library
				$sql = "SELECT \"{$ikey}\" FROM {$table} WHERE \"{$ikey}\" = '{$value}';";
				$result = mysql_query($sql);
				$rowcount = @mysql_num_rows($result);
				if ($rowcount > 0) {
					$retval = true;
					setNoticeMsg("asnum: this number already exists.");
				} else {
					$retval = false;
				}
			}
		} else {
			setNoticeMsg("asnum: invalid format.");
			$retval = true;
		}
		return $retval;
	}
	# $ikey: country
	# checks: valid 2 char country code
	# valid input: US, CR, AU, AT, DE
	public function countryCheck($inputval) {
		/* commented out for further use.
		* # countries defined by http://www.davros.org/misc/iso3166.html or look for ISO 3166
		* $countries = array("AF", "AL",	"DZ",	"AS",	"AD",	"AO",	"AI",	"AQ",	"AG",	"AR",
		* 	"AM",	"AW",	"AU",	"AT",	"AZ",	"BS",	"BH",	"BD",	"BB",	"BY",	"BE",	"BZ",	"BJ",
		* 	"BM",	"BT",	"BO",	"BA",	"BW",	"BV",	"BR",	"IO",	"VG",	"BN",	"BG",	"BF",	"BI",
		* 	"KH",	"CM",	"CA",	"CV",	"KY",	"CF",	"TD",	"CL",	"CN",	"CX",	"CC",	"CO",	"KM",
		* 	"CD",	"CG",	"CK",	"CR",	"CI",	"CU",	"CY",	"CZ",	"DK",	"DJ",	"DM",	"DO",	"EC",
		* 	"EG",	"SV",	"GQ",	"ER",	"EE",	"ET",	"FO",	"FK",	"FJ",	"FI",	"FR",	"GF",	"PF",
		* 	"TF",	"GA",	"GM",	"GE",	"DE",	"GH",	"GI",	"GR",	"GL",	"GD",	"GP",	"GU",	"GT",
		* 	"GN",	"GW",	"GY",	"HT",	"HM",	"VA",	"HN",	"HK",	"HR",	"HU",	"IS",	"IN",	"ID",
		* 	"IR",	"IQ",	"IE",	"IL",	"IT",	"JM",	"JP",	"JO",	"KZ",	"KE",	"KI",	"KP",	"KR",	
		* 	"KW",	"KG",	"LA",	"LV",	"LB",	"LS",	"LR",	"LY",	"LI",	"LT",	"LU",	"MO",	"MK",	
		* 	"MG",	"MW",	"MY",	"MV",	"ML",	"MT",	"MH",	"MQ",	"MR",	"MU",	"YT",	"MX",	"FM",	
		* 	"MD",	"MC",	"MN",	"MS",	"MA",	"MZ",	"MM",	"NA",	"NR",	"NP",	"AN",	"NL",	"NC",	
		* 	"NZ",	"NI",	"NE",	"NG",	"NU",	"NF",	"MP",	"NO",	"OM",	"PK",	"PW",	"PS",	"PA",	
		* 	"PG",	"PY",	"PE",	"PH",	"PN",	"PL",	"PT",	"PR",	"QA",	"RE",	"RO",	"RU",	"RW",	
		* 	"SH",	"KN",	"LC",	"PM",	"VC",	"WS",	"SM",	"ST",	"SA",	"SN",	"CS",	"SC",	"SL",	
		* 	"SG",	"SK",	"SI",	"SB",	"SO",	"ZA",	"GS",	"ES",	"LK",	"SD",	"SR",	"SJ",	"SZ",	
		* 	"SE",	"CH",	"SY",	"TW",	"TJ",	"TZ",	"TH",	"TL",	"TG",	"TK",	"TO",	"TT",	"TN",	
		* 	"TR",	"TM",	"TC",	"TV",	"VI",	"UG",	"UA",	"AE",	"GB",	"UM",	"US",	"UY",	"UZ",	
		* 	"VU",	"VE",	"VN",	"WF",	"EH",	"YE",	"ZM",	"ZW"
		* );
		* $vallen = strlen($value);
		* if (($vallen == 2) && (in_array($value, $countries) == true)) {
		* 	# dummy
		* } else {
		* 	$error = 1;
		* 	$this->auto_index++;
		* 	$this->settings->xmlobject->error->entry[$this->auto_index] = new stdClass;
		* 	$this->settings->xmlobject->error->entry[$this->auto_index]->text = "country: neplatny format zeme / neexistujici zeme.";
		* }
		*}
		*/
		$inplen = strlen($inputval);
		if (($inplen == 2) && ($inputval == 'CR')) {
			$retval = false;
		} else {
			setNoticeMsg("country: country doesn't exist.");
			$retval = true;
		}
		return $retval;
	}
	# $ikey: netname, as-name
	# checks: valid string
	# total: 256 characters
	# valid input: a_t-team01
	public function charnumCheck($inputval, $ikey, $table) {
		$inplen = strlen($inputval);
		if (preg_match("/^[A-Za-z]+{1}[0-9A-Za-z\_\-]+([0-9]+)$/", $inputval) && $inplen < 128) {
			$retval = false;
		} else {
			setNoticeMsg("{$ikey}: invalid format.");
			$retval = true;
		}
		return $retval;
	}
	# $ikey: route
	# checks: valid ipv4 address with netmask
	# valid input: 10.1.1.1/32
	public function ipv4Check($inputval = null, $ikey, $table = null) {
		$rowcount = -1;
		if (!is_null($inputval) && !is_null($table)) {
			if (preg_match("/[0-9]{1,2}\.[0-9]{1,2}\.[0-9]{1,2}\.[0-9]{1,2}/([0-9]{1,2})$/", $inputval)) {
				list($ip, $mask) = explode("/", $inputval);
				if (@inet_pton($ip) !== false && $mask > 7 && $mask < 33) {
					# ToDo - CHECK ME!
					# ToDo - DB
					$sql = "SELECT \"{$ikey}\" FROM {$table} WHERE \"{$ikey}\" = INET_ATON({$ip}) AND mask = {$mask};";
					$result = mysql_query($sql);
					$rowcount = @mysql_num_rows($result);
					if ($rowcount > 0) {
						setNoticeMsg("{$ikey}: this IPv4 range is already taken;");
						$retval = true;
					} else {
						$retval = false;
					}
				} else {
					setNoticeMsg("{$ikey}: invalid IPv4 range.");
					$retval = true;
				}
			} else {
				setNoticeMsg("{$ikey}: invalid IPv4 range.");
				$retval = true;
			}
		}
		return $retval;
	}
	# $ikey: autnum
	# valid input: AS12345
	public function originCheck($inputval, $ikey) {
		# jestli chces multiple, tak si ho dodelej sam. origin - single + mandatory
		if (preg_match("/^AS[0-9]{5,5}$/", $inputval)) {
			# ToDo - DB
			$sql = "SELECT aut-num FROM aut-num WHERE aut-num = '{$inputval}'";
			$result = mysql_query($sql);
			$rowcount = @mysql_num_rows($result);
			if ($rowcount > 0) {
				$retval = false;
			} else {
				setNoticeMsg("origin: object(s) doesn't exist.");
				$retval = true;
			}
		} else {
			setNoticeMsg("origin: invalid format.");
			$retval = true;
		}
		return $retval;
	}
	# desc: checks auth field and it's not an auth function!
	# $inputval: string;
	# $ikey: string;
	# @return: bool;
	public function authCheck($inputval, $ikey) {
		if (preg_match('/^(MD5-PW \$1\$).{30}(\/)$/', $inputval) == 1) {
			// mela by nasledovat kontrola, zda je MD5 hash dlouhy 30 znaku a ukonceny '/'
			// otazkou je, jak validovat MD5 hash, ale. pokud nekdo zada invalidni hash,
			// tak uz se k objektu nedostane a je to, vicemene, jeho problem
			// https://www.ripe.net/cgi-bin/crypt.cgi
			$retval = false;
		} elseif (preg_match('/^(PGKEY-)[0-9]{8}$/', $inputval) == 1) {
			// ToDo
			// zde se odkazujeme na existujici objekt key-cert
			// kontrola, zda je objekt v databazi
			setNoticeMsg("{$ikey}: unsupported auth format;");
			$retval = false;
		} elseif (preg_match('/^(X509-)[0-9]{1,8}$/', $inputval) == 1) {
			// ToDo
			// zde se odkazujeme na existujici objekt key-cert
			// kontrola, zda je objekt v databazi
			setNoticeMsg("{$ikey}: unsupported auth format;");
			$retval = false;
		} else {
			setNoticeMsg("{$ikey}: invalid format.");
			$retval = true;
		} // if regexp MD5
		return $retval;
	}
	# desc: checks if domain exists;
	public function revsrvCheck($inputval, $ikey) {
		$error = 0;
		# ToDo - check if this works;
		# note: no PEAR here!
		if (checkdnsrr($inputval) == false) {
			setNoticeMsg("{$ikey}: domain not found;");
			$retval = true;
		} else {
			$retval = false;
		}
		return $retval;
	}
	# desc: checks, if claimed source is supported by db;
	public function sourceCheck($source, $ikey) {
		require_once("lib/db.php");
		$db = new db();
		$sql1 = "SELECT COUNT(*) AS rowcount FROM source WHERE source = '{$source}';";
		$arr = $db->query($sql1);
		if ($arr[0]->rowcount == 1)
		{
			$retval = false;
		} else {
			setNoticeMsg("{$ikey}: source not found;");
			$retval = true;
		}
		return $retval;
	}
	# fetch and parse data from form
	# $datain: string;
	# @return: object;
	public function convertData($datain = null) {
		if (!is_null($datain))
		{
			$datain = addslashes($datain);
			$datain = preg_replace('/^\s*/', "", $datain);
			$datain = preg_replace('/\s*$/', "", $datain);
			// so far so good
			if (!empty($datain)) {
				$array = preg_split("/[\n]+/", $datain);
				$dataout = new StdClass;
				$index = 0;
				foreach ($array as $object) {
					$handle = null;
					$data = null;
					@list($handle, $data) = explode(":", $object);
					$handle = preg_replace('/^\s*$/', "", $handle);
					$data = preg_replace('/^\s*/', "", $data);
					$data = preg_replace('/\s*$/', "", $data);
					if (!empty($data)) {
						$tmp = new StdClass;
						$tmp->value = $data;
						$tmp->formorder = $index;
						$dataout->{$handle}[] = $tmp;
						$index++;
					}
				}
				return $dataout;
			} else {
				return false;
			}
		} else {
			return false;
		}
	}
	# char conversion
	public function char2ASCII($text) {
		$char_code[3] = "#\#+#s";
		$char_code[2] = "#\<+#s";
		$char_code[1] = "#\>+#s";
		$char_code[0] = "#(&[^\#0-9]{1,3}?)+#s";
		$char_replacement[3] = "&#35;";
		$char_replacement[2] = "&#60;";
		$char_replacement[1] = "&#62;";
		$char_replacement[0] = "&amp;";
		$output = preg_replace($char_code, $char_replacement, $text, -1);
	return $output;
	}
}
?>
