<?php
class form extends defaultLib
{
	public $settings;
	public $auto_index = -1;
	public $path = "";
	// ready-up
	function __construct()
 	{
		$this->settings = new stdClass;
		$settings = $this->settings;
		$settings->xmlobject = new stdClass;
		// layout to load
		$settings->layout = "layout.xsl";
	}
	function __destruct()
	{
		unset($this->settings);
	}
	// go
	public function init()
 	{
		$settings = $this->settings;
		$xml = $this->settings->xmlobject;
		$this->path = $this->getPath();
		$action = "foo";
		if (isset($_GET['action']))
	 	{
			$action = $this->stripMe($_GET['action']);
		}
		switch ($action)
	 	{
		case 'loadobject':
			$this->loadObject();
			break;
		case 'addobject':
			$this->addObject();
			break;
		case 'editobject':
			$this->editObject();
			break;
		case 'updateobject':
			$this->updateObject();
			break;
		case 'deleteobject':
			$this->deleteObject();
			break;
		default:
			$this->loadObject();
			break;
		}
	}
	# $_GET['object']: string;
	# @return: void;
	private function addObject()
	{
		$object = "";
		$datain = "";
		if (isset($_GET['object']))
			$object = $this->stripMe($_GET['object']);
		if (isset($_POST['inputarea']))
			$datain = $_POST['inputarea'];
		switch ($object)
		{
		case "person":
		case "role":
		case "mntner":
		case "autnum":
		case "inetnum":
		case "inet6num":
		case "route":
		case "domain":
			try
			{
				if (file_exists("{$this->path}lib/{$object}.php") && is_readable("{$this->path}lib/{$object}.php"))
				{
					require_once("{$this->path}lib/{$object}.php");
					$foo = new $object($this->path);
					if ($foo->objectAdd($datain) == true) {
						$this->auto_index++;
						$this->settings->import[$this->auto_index] = new StdClass;
						$this->settings->import[$this->auto_index] = "{$this->path}xsl/index/index.xsl";
					}
				} else {
					throw new Exception("Unable to process object. Required file '{$this->path}lib/{$object}.php' not found
						or can't be open.");
				}
			}
		 	catch (Exception $f)
			{
				$xml = $this->settings->xmlobject;
				setNoticeMsg($f->getMessage());
				$xml->inputarea = $datain;
				// load form.xls
				$this->auto_index++;
				$this->settings->import[$this->auto_index] = new StdClass;
				$this->settings->import[$this->auto_index] = "{$this->path}xsl/form/form.xsl";
			}
			break;
		default:
			// import content
			$this->auto_index++;
			$this->settings->import[$this->auto_index] = new StdClass;
			$this->settings->import[$this->auto_index] = "{$this->path}xsl/form/form.xsl";
			$xml = $this->settings->xmlobject;
			$xml->inputarea = "You're trying to add an invalid object.";
			$xml->formlink = "";
			break;
		}
	}
	private function editObject()
	{
		/* ToDo */
		$settings = $this->settings;
		$settings->import[] = "xsl/form/formedit.xsl";
		$nichdl = "OP123";
		$object = "person";
		require_once("{$this->path}lib/person.php");
		$person = new person($this->path);
		$xml = $this->settings->xmlobject;
		$xml->obj = $person->objectShow($nichdl);
		unset($xml->obj->changed);
		$xml->newline = "\n";
		$xml->formaction = "index.php?module=form&#38;action=updateobject&#38;object={$object}";
	}
	# desc: gets object structure in array;
	# $objectname: string;
	# @return: array or NULL;
	private function getObject($objectname = NULL)
	{
		if (!is_null($objectname) && file_exists("{$this->path}lib/{$objectname}.php") && is_readable("{$this->path}lib/{$objectname}.php"))
		{
			require_once("{$this->path}lib/{$objectname}.php");
			$foo = new $objectname;
			setDebugMsg("Loading object: '{$objectname}';");
			return $foo->objectSet();
		} else {
			setDebugMsg("Unable to open file: '{$this->path}lib/{$objectname}.php'");
			return NULL;
		}
	}
	# desc: loads text into input form
	# $_GET['object']: string;
	# @return: void;
	private function loadObject() 
	{
		$xml = $this->settings->xmlobject;
		$object = "";
		if (isset($_GET['object']))
		{
			$object = $this->stripMe($_GET['object']);
		}
		if (!isset($_SESSION['RIPESOURCE']))
		{
			require_once("{$this->path}config.php");
			$_SESSION['RIPESOURCE'] = RIPESOURCE;
		}
		setDebugMsg("Object to load: '{$object}';");
		// why? because you could easilly sniff around
		// and cause unexpected errors;
		// this could be avoided by placing object.php
		// into own directory, but ...;
		switch ($object)
		{
		case "person":
		case "role":
		case "mntner":
		case "autnum":
		case "inetnum":
		case "inet6num":
		case "route":
		case "domain":
			$arr = $this->getObject($object);
			break;
		default:
			$xml->inputarea = "Choose the object from the menu above.\nMake sure you've selected source or the default one is going to be used.";
			$xml->formaction = "";
			break;
		}
		if (isset($arr) && is_array($arr))
		{
			$counter = 0;
			$itemcount = count($arr);
			$xml->formaction = "index.php?module=form&#38;action=addobject&#38;object={$object}";
			foreach ($arr as $k=>$v) {
				list($mandatory, $type) = explode(":", $v);
				if ($k == "source")
				{
					$xml->inputarea.="{$k}: {$_SESSION['RIPESOURCE']}";
					break;
				}
				$xml->inputarea.="{$k}: (";
				if ($mandatory == 1)
				{
					$xml->inputarea.="mandatory,";
				} else {
					$xml->inputarea.="optional,";
				}
				if ($type == 0)
				{
					$xml->inputarea.="single";
				} else {
					$xml->inputarea.="multiple";
				}
				$xml->inputarea.=")";
				if (++$counter < $itemcount)
					$xml->inputarea.="\n";
			}
		}
		$this->auto_index++;
		$this->settings->import[$this->auto_index] = new StdClass;
		$this->settings->import[$this->auto_index] = "{$this->path}xsl/form/form.xsl";
	}
	private function updateObject()
	{
		$object = "";
		if (isset($_POST['object']))
			$object = $this->stripMe($_POST['object']);
		// why? because you could easilly sniff around
		// and cause unexpected errors;
		// this could be avoided by placing object.php
		// into own directory, but ...;
		switch ($object)
		{
		case "person":
		case "role":
		case "mntner":
		case "autnum":
		case "inetnum":
		case "inet6num":
		case "route":
		case "domain":
			require_once("{$this->path}lib/{$object}.php");
			$foo = new $object($this->path);
			break;
		default:
			break;
		}
	}
}
?>
