<?php
# BUGs: ne vsechny polozky se checkuji na delku retezce!!!
# Notes:
# 	objectentries -> 
# 		entryname => mandatory:single/multiple | string => 0/1:0/1
# 		0 = is non-mandatory; 1 = is mandatory;
# 		0 = is single; 1 = is multiple;
class checkers {
	public $settings;
	public $data;
	public $objectarray;
	public $action;
	public $object;
	public $rccond;
	public $auto_index;
	# desc: checks for mandatory objects and returns 0 = ok, 1 = fault;
	public function checkObject($objectstruct = null, $inputdata) {
		$error = 0;
		if (is_array($objectstructure) && !is_null($objectstructure) && is_array($this->objectarray)) {
			foreach ($objectstructure as $key => $value) {
				list($is_mandatory, $type) = explode(":", $value);
				if (array_key_exists($key, $this->objectarray) == true) {
					# *cough*
					if (count($this->objectarray["{$key}"]) > 1 && $type == 0) {
						$this->addError("{$key}: bylo zadano vice jak 1 zaznamu pro objekt typu single.");
						$error = 1;
					} elseif (count($this->objectarray["{$key}"]) < 1 ) {
						$this->addError("{$key}: bylo zadano mene jak 1 zaznamu pro objekt typu single / multiple.");
						$error = 1;
					}
					if ($this->checkEmptyVal($key) == 1) {
						$this->addError("{$key}: byla nalezena prazdna hodnota.");
						$error = 1;
					}
				} else {
					if ($is_mandatory == 0) {
						# non-mandatory object
					} else {
						$this->addError("{$key}: povinny objekt nebyl zadan.");
						$error = 0;
					}
				}	
			}
		} else {
			$this->addError("funkce submit::checkMandatory: vstup neni typu array.");
			$error = 0;
		}
		return $error;
	}
	# desc: checks whenever value is empty or not;
	# $inputval: string;
	# @return: bool;//false==not empty;true==empty;
	public function checkEmptyVal($inputval, $ikey = null) {
		if (empty($inputval)) {
			return 1;
			#$this->addError("{$ikey}: prazdna hodnota.");
		} else {
			return 0;
		}
	}
	# $ikey: person;
	# valid input = only chars with whitespace(s)
	# total - 256 characters
	# i.e. John Smith
	public function nameCheck($inputval, $ikey) {
		$error = 0;
		$var = preg_replace("/^\s{2}+$/", "", $inputval);
		if (preg_match("/^[A-Za-z]+[\s]{1}[A-Za-z]+$/", $var)) {
			# everything is OK
			$this->auto_index++;
			$this->dbobject->{$ikey}[$this->auto_index] = new stdClass;
			$this->dbobject->{$ikey}[$this->auto_index] = $var;
		} else {
			$this->addError("{$ikey}: neplatny format.");
			$error = 1;
		}
		$this->rccond = $this->rccond + $error;
		return $error;
	}
	# $ikey: descr;
	# valid input = only chars with whitespace(s)
	# total - 256 characters
	# i.e. John Smith
	public function charOnlyCheck($inputval, $ikey) {
		$error = 0;
		$var = preg_replace("/^\s{2}+$/", "", $inputval);
		if (preg_match("/^[A-z\s]+$/", $var)) {
			# everything is OK
			$this->auto_index++;
			$this->dbobject->{$ikey}[$this->auto_index] = new stdClass;
			$this->dbobject->{$ikey}[$this->auto_index] = $inputval;
		} else {
			$this->addError("{$ikey}: neplatny format.");
			$error = 1;
		}
		$this->rccond = $this->rccond + $error;
		return $error;
	}
			
	# $ikey: e-mail, notify, changed;
	# valid input = valid email address
	# domain - 255 max
	# user - 64 max
	# total - 320 including '@'
	# i.e. pappa.john@yahoo.com
	public function emailCheck($inputval, $ikey) {
		$error = 0;
		$strip = preg_replace("/[\s]*$/", "", $inputval);
		if (preg_match("/^[A-z0-9_\.]+@[A-z0-9\.-]+\.[A-z]{2,4}$/", $strip)) {
			# dummy
			if ($ikey == "changed") {
				date_default_timezone_set('Europe/Prague');
				$moddate = date("Ymd");
				$inputval = "{$inputval} {$moddate}";
			}
			$this->auto_index++;
			$this->dbobject->{$ikey}[$this->auto_index] = new stdClass;
			$this->dbobject->{$ikey}[$this->auto_index] = $inputval;
		} else {
			$this->addError("{$ikey}: neplatny format.");
			$error = 1;
		}
		$this->rccond = $this->rccond + $error;
		return $error;
	}
						
	# $ikey: phone, fax-no;
	# valid input = phone or fax number
	# total - 24 including reserve
	# i.e. +420 201 300 500
	public function phoneCheck($inputval, $ikey) {
		$error = 0;
		if (preg_match("/^[\+][1-9]/", $inputval)) {
			$stripped = preg_replace("/[\s]*/", "", $inputval);
			$stripped = preg_replace("/^\+/", "", $stripped);
			if (preg_match("/^[\d]+$/", $stripped)) {
				# dummy
				$this->auto_index++;
				$this->dbobject->{$ikey}[$this->auto_index] = new stdClass;
				$this->dbobject->{$ikey}[$this->auto_index] = "{$inputval}";
			} else {
				$this->addError("{$ikey}: neplatny format");
				$error = 1;
			}
		} else {
			$this->addError("{$ikey}: neplatny format.");
			$error = 1;
		}
		$this->rccond = $this->rccond + $error;
		return $error;
	}
						
	# $ikey: nic-hdl, mntner
	# $table: where to get data
	# valid input = 2 or 4 chars followed up to 5 digits, fist digit must not be 0
	# i.e. OP12345
	# note: original RIPE nic-hdl supports format like this(?) OP12345-<source>
	#				this format is not supported here!
	public function nichdlCheck($inputval, $ikey, $table = null, $column) {
		$error = 0;
		if (preg_match("/^[A-z]{2,4}/", $inputval)) {
			$stripped = preg_replace("/^[A-z]{2,4}/", "", $inputval);
			if (preg_match("/^[1-9]([0-9]{1,4})$/", $stripped)) {
				$sql = "SELECT {$column} FROM {$table} WHERE {$column} = '{$inputval}';";
				$result = mysql_query($sql);
				$rowcount = @mysql_num_rows($result);
				if ($rowcount == 0) {
					# dummy
					$this->auto_index++;
					$this->dbobject->{$ikey}[$this->auto_index] = new stdClass;
					$this->dbobject->{$ikey}[$this->auto_index] = $inputval;
				} else {
					$this->addError("{$ikey}: tato hodnota jiz existuje.");
					$error = 1;
				}
			} else {
				$this->addError("{$ikey}: neplatny format.");
				$error = 1;
			}
		} else {
			$this->addError("{$ikey}: neplatny format.");
			$error = 1;
		}
		$this->rccond = $this->rccond + $error;
		return $error;
	}

	# $ikey: mnt-by(nic-hdl)
	# checks: if mntnet exists and given password is valid
	# valid input: nic-hdl
	public function mntbyCheck($inputval, $ikey) {
		// the dumbest solution in the history! :[
		$error = 0;
		if (preg_match("/^[A-z]{2,4}/", $inputval)) {
			$stripped = preg_replace("/^[A-z]{2,4}/", "", $inputval);
			if (preg_match("/^[1-9]([0-9]{1,4})$/", $stripped)) {
				$sqlMntCheck = "SELECT mntner, password FROM mntner WHERE mntner = '{$inputval}';";
				$resultMntCheck = mysql_query($sqlMntCheck);
				$rowcount = mysql_num_rows($resultMntCheck); 
				if ($rowcount == 1) {
					if (array_key_exists("password", $this->objectarray)) {
						$row = mysql_fetch_assoc($resultMntCheck);
						$arr1 = explode(",", $row['auth']);
						$count1 = array_count_values($arr1);
						$arr2 = array_values($this->objectarray["password"]);
						$count2 = array_count_values($arr2);
						for ($a = 0; $a < $count1; $a++) {
							if (preg_match('/^(MD5-PW \$1\$).{30}(\/)$/', $arr1[$a]) == 1) {
								for ($b = 0; $b < $count2; $b++) {
									$password = "MD5-PW $1". md5($arr[$b]) . "/";
									if ($password == $arr[$a]) {
										# dummy - authorized
										$this->auto_index++;
										$this->dbobject->{$ikey}[$this->auto_index] = new stdClass;
										$this->dbobject->{$ikey}[$this->auto_index] = $inputval;
									} else {
										// error, but we don't want to compromise how many passwords have failed.
										// we'll deal about that later champs.
										$error = 1;
									} // if password
								} // for b
							} // if preg_match
						} // for a
					} else {
						$error = 1;
						$this->addError("{$ikey}: pole 'password' nenalezeno.");
					} // if array_key_exists
				} else {
					$this->addError("{$ikey}: neexistujici objekt.");
					$error = 1;
				} // if rowcount = 1
			} else {
				$error = 1;
				$this->addError("{$ikey}: spatny format.");
			} // if preg_match 1-9
		} else {
			$error = 1;
			$this->addError("{$ikey}: spatny format.");
		} // if preg_match A-z
		if ($error == 1) {
			// now it's the right time to deal with password error.
			$this->addError("mnt-by: nepodarilo se autorizovat {$inputval}.");
		}
		$this->rccond = $this->rccond + $error;
		return $error;
	}
	# $ikey: whatever
	# checks if value has not exceeded max allowed lenght
	public function maxlenghtCheck($inputval, $ikey) {
		$error = 0;
		$length = strlen($inputval);
		if ($length > 128) {
			$this->addError("{$ikey}: hodnota prekrocila max. povolenou delku.");
			$error = 1;
		} else {
			# dummy
			$this->auto_index++;
			$this->dbobject->{$ikey}[$this->auto_index] = new stdClass;
			$this->dbobject->{$ikey}[$this->auto_index] = $inputval;
		}
		$this->rccond = $this->rccond + $error;
		return $error;
	}

	# $ikey: nic-hdl
	# checks if person or role object exists
	# var: string
	public function contactCheck($inputval, $ikey) {
		$error = 0;
		if (preg_match("/^[A-z]{2,4}/", $inputval)) {
			$stripped = preg_replace("/^[A-z]{2,4}/", "", $inputval);
			if (preg_match("/^[1-9]([0-9]{1,4})$/", $stripped)) {
				# ToDo: melo by to snad fungovat
				$sql1 = "SELECT \"nichdl\" FROM person WHERE nichdl = '{$inputval}';";
				$sql2 = "SELECT \"nichdl\" FROM role WHERE nichdl = '{$inputval}';";
				$result1 = mysql_query($sql1);
				$result2 = mysql_query($sql2);
				$rowcount1 = mysql_num_rows($result1);
				$rowcount2 = mysql_num_rows($result2);
				$itemcount = count($this->objectarray["{$ikey}"]);
				$rowcount = $rowcount1+$rowcount2;
				if ($rowcount == $itemcount) {
					# dummy
					$this->auto_index++;
					$this->dbobject->{$ikey}[$this->auto_index] = new stdClass;
					$this->dbobject->{$ikey}[$this->auto_index] = $inputval;
				} else {
					$error = 1;
					$this->addError("{$ikey}: neexistujici objekt(y).");
				}
			}
		} else {
			$error = 1;
			$this->addError("{$ikey}: nespravny format.");
		}
		$this->rccond = $this->rccond + $error;
		return $error;
	}

	# $ikey: autnum
	# checks: for valid autnum
	# valid input: AS12345 & 12345 > 64000
	public function asnumCheck($inputval, $ikey, $table) {
		$error = 0;
		$rowcount = -1;
		if (preg_match("/^AS[0-9]{5,5}$/", $inputval)) {
			# tuto podminku lze s klidem vynechat
			$string = substr($inputval, 2);
			# ToDo - check, jestli opravdu funguje $string < 64000
			if ($string < 64000) {
				$error = 1;
			} else {
				# dummy
				$sql = "SELECT {$ikey} FROM {$table} WHERE {$ikey} = '{$value}';";
				$result = mysql_query($sql);
				$rowcount = @mysql_num_rows($result);
				if ($rowcount > 0) {
					$error = 1;
					$this->addError("asnum: toto cislo jiz existuje.");
				} else {
					# dummy
					$this->auto_index++;
					$this->dbobject->{$ikey}[$this->auto_index] = new stdClass;
					$this->dbobject->{$ikey}[$this->auto_index] = $inputval;
				}
			}
		} else {
			$error = 1;
			$this->addError("asnum: nespravny format.");
		}
		$this->rccond = $this->rccond + $error;
		return $error;
	}

	# $ikey: country
	# checks: valid 2 char country code
	# valid input: US, CR, AU, AT, DE
	public function countryCheck($inputval) {
		$error = 0;
		/* commented out for further use.
		* # countries defined by http://www.davros.org/misc/iso3166.html or look for ISO 3166
		* $countries = array("AF", "AL",	"DZ",	"AS",	"AD",	"AO",	"AI",	"AQ",	"AG",	"AR",	"AM",	"AW",	"AU",	"AT",	"AZ",	"BS",	"BH",	"BD",	"BB",	"BY",	"BE",	"BZ",	"BJ",	"BM",	"BT",	"BO",	"BA",	"BW",	"BV",	"BR",	"IO",	"VG",	"BN",	"BG",	"BF",	"BI",	"KH",	"CM",	"CA",	"CV",	"KY",	"CF",	"TD",	"CL",	"CN",	"CX",	"CC",	"CO",	"KM",	"CD",	"CG",	"CK",	"CR",	"CI",	"CU",	"CY",	"CZ",	"DK",	"DJ",	"DM",	"DO",	"EC",	"EG",	"SV",	"GQ",	"ER",	"EE",	"ET",	"FO",	"FK",	"FJ",	"FI",	"FR",	"GF",	"PF",	"TF",	"GA",	"GM",	"GE",	"DE",	"GH",	"GI",	"GR",	"GL",	"GD",	"GP",	"GU",	"GT",	"GN",	"GW",	"GY",	"HT",	"HM",	"VA",	"HN",	"HK",	"HR",	"HU",	"IS",	"IN",	"ID",	"IR",	"IQ",	"IE",	"IL",	"IT",	"JM",	"JP",	"JO",	"KZ",	"KE",	"KI",	"KP",	"KR",	"KW",	"KG",	"LA",	"LV",	"LB",	"LS",	"LR",	"LY",	"LI",	"LT",	"LU",	"MO",	"MK",	"MG",	"MW",	"MY",	"MV",	"ML",	"MT",	"MH",	"MQ",	"MR",	"MU",	"YT",	"MX",	"FM",	"MD",	"MC",	"MN",	"MS",	"MA",	"MZ",	"MM",	"NA",	"NR",	"NP",	"AN",	"NL",	"NC",	"NZ",	"NI",	"NE",	"NG",	"NU",	"NF",	"MP",	"NO",	"OM",	"PK",	"PW",	"PS",	"PA",	"PG",	"PY",	"PE",	"PH",	"PN",	"PL",	"PT",	"PR",	"QA",	"RE",	"RO",	"RU",	"RW",	"SH",	"KN",	"LC",	"PM",	"VC",	"WS",	"SM",	"ST",	"SA",	"SN",	"CS",	"SC",	"SL",	"SG",	"SK",	"SI",	"SB",	"SO",	"ZA",	"GS",	"ES",	"LK",	"SD",	"SR",	"SJ",	"SZ",	"SE",	"CH",	"SY",	"TW",	"TJ",	"TZ",	"TH",	"TL",	"TG",	"TK",	"TO",	"TT",	"TN",	"TR",	"TM",	"TC",	"TV",	"VI",	"UG",	"UA",	"AE",	"GB",	"UM",	"US",	"UY",	"UZ",	"VU",	"VE",	"VN",	"WF",	"EH",	"YE",	"ZM",	"ZW");
		* $vallen = strlen($value);
		* if (($vallen == 2) && (in_array($value, $countries) == true)) {
		* 	# dummy
		* } else {
		* 	$error = 1;
		* 	$this->auto_index++;
		* 	$this->settings->xmlobject->error->entry[$this->auto_index] = new stdClass;
		* 	$this->settings->xmlobject->error->entry[$this->auto_index]->text = "country: neplatny format zeme / neexistujici zeme.";
		* }
		*}
		*/
		$inplen = strlen($inputval);
		if (($inplen == 2) && ($inputval == 'CR')) {
			# dummy
			$this->auto_index++;
			$this->dbobject->{$ikey}[$this->auto_index] = new stdClass;
			$this->dbobject->{$ikey}[$this->auto_index] = $inputval;
		} else {
			$error = 1;
			$this->addError("country: neplatny format zeme / neexistujici zeme.");
		}
		$this->rccond = $this->rccond + $error;
		return $error;
	}

	# $ikey: netname, as-name
	# checks: valid string
	# total: 256 characters
	# valid input: a_t-team01
	public function charnumCheck($inputval, $ikey, $table) {
		$error = 0;
		$inplen = strlen($inputval);
		if (preg_match("/^[A-Za-z]+{1}[0-9A-Za-z\_\-]+([0-9]+)$/", $inputval) && $inplen < 128) {
			# dummy
			$this->auto_index++;
			$this->dbobject->{$ikey}[$this->auto_index] = new stdClass;
			$this->dbobject->{$ikey}[$this->auto_index] = $inputval;
		} else {
			$error = 1;
			$this->addError("{$ikey}: neplatny format.");
		}
		$this->rccond = $this->rccond + $error;
		return $error;
	}

	# $ikey: route
	# checks: valid ipv4 address with netmask
	# valid input: 10.1.1.1/32
	public function ipv4Check($inputval = null, $ikey, $table = null) {
		$error = 0;
		$rowcount = -1;
		if (!is_null($inputval) && !is_null($table)) {
			if (preg_match("/[0-9]{1,2}\.[0-9]{1,2}\.[0-9]{1,2}\.[0-9]{1,2}/([0-9]{1,2})$/", $inputval)) {
				list($ip, $mask) = explode("/", $inputval);
				if (@inet_pton($ip) !== false && $mask > 7 && $mask < 33) {
					# ToDo - CHECK ME!
					$sql = "SELECT {$ikey} FROM {$table} WHERE {$ikey} = INET_ATON({$ip}) AND mask = {$mask};";
					$result = mysql_query($sql);
					$rowcount = @mysql_num_rows($result);
					if ($rowcount > 0) {
						$error = 1;
						$this->addError("{$ikey}: tento zaznam jiz existuje;");
					} else {
						# dummy
						$this->dbobject->ip = new stdClass;
						$this->dbobject->netmask = new stdClass;
						$this->dbobject->ip = $ip;
						$this->dbobject->netmask = $mask;
					}
				} else {
					$error = 1;
					$this->addError("{$ikey}: nevalidni IPv4 rozsah.");
				}
			} else {
				$error = 1;
				$this->addError("{$ikey}: nevalidni IPv4 rozsah.");
			}
		}
		$this->rccond = $this->rccond + $error;
		return $error;
	}

	# $ikey: autnum
	# valid input: AS12345
	public function originCheck($inputval, $ikey) {
		# jestli chces multiple, tak si ho dodelej sam. origin - single + mandatory
		$error = 0;
		if (preg_match("/^AS[0-9]{5,5}$/", $inputval)) {
			$sql = "SELECT aut-num FROM aut-num WHERE aut-num = '{$inputval}'";
			$result = mysql_query($sql);
			$rowcount = @mysql_num_rows($result);
			if ($rowcount > 0) {
				# dummy
				$this->auto_index++;
				$this->dbobject->{$ikey}[$this->auto_index] = new stdClass;
				$this->dbobject->{$ikey}[$this->auto_index] = $inputval;
			} else {
				$error = 1;
				$this->addError("origin: neexistujici objekt(y).");
			}
		} else {
			$error = 1;
			$this->addError("origin: nespravny format.");
		}
		$this->rccond = $this->rccond + $error;
		return $error;
	}

	public function authCheck($inputval, $ikey) {
		$error = 0;
		if (preg_match('/^(MD5-PW \$1\$).{30}(\/)$/', $inputval) == 1) {
			// mela by nasledovat kontrola, zda je MD5 hash dlouhy 30 znaku a ukonceny '/'
			// otazkou je, jak validovat MD5 hash, ale. pokud nekdo zada invalidni hash,
			// tak uz se k objektu nedostane a je to, vicemene, jeho problem
			// https://www.ripe.net/cgi-bin/crypt.cgi
			$this->auto_index++;
			$this->dbobject->{$ikey}[$this->auto_index] = new StdClass;
			$this->dbobject->{$ikey}[$this->auto_index] = $inputval;
			$error = 0;
		} elseif (preg_match('/^(PGKEY-)[0-9]{8}$/', $inputval) == 1) {
			// ToDo
			// zde se odkazujeme na existujici objekt key-cert
			// kontrola, zda je objekt v databazi
			$this->auto_index++;
			$this->dbobject->{$ikey}[$this->auto_index] = new StdClass;
			$this->dbobject->{$ikey}[$this->auto_index] = $inputval;
			$error = 0;
		} elseif (preg_match('/^(X509-)[0-9]{1,8}$/', $inputval) == 1) {
			// ToDo
			// zde se odkazujeme na existujici objekt key-cert
			// kontrola, zda je objekt v databazi
			$this->auto_index++;
			$this->dbobject->{$ikey}[$this->auto_index] = new StdClass;
			$this->dbobject->{$ikey}[$this->auto_index] = $inputval;
			$error = 0;
		} else {
			$error = 1;
			$this->addError("{$ikey}: nespravny format.");
		} // if regexp MD5
		return $error;
	}

	public function revsrvCheck($inputval, $ikey) {
		$error = 0;
		# ToDo - check if this works;
		# note: no PEAR here!
		if (checkdnsrr($inputval) == false) {
			$error = 1;
			$this->auto_index++;
			$this->dbobject->{$ikey}[$this->auto_index] = new stdClass;
			$this->dbobject->{$ikey}[$this->auto_index] = $inputval;
		} else {
			$this->auto_index++;
			$this->dbobject->{$ikey}[$this->auto_index] = new stdClass;
			$this->dbobject->{$ikey}[$this->auto_index] = $inputval;
		}
		return $error;
	}

	# fetch and parse data from form
	public function convertData($datain = null) {
		if (!is_null($datain))
		{
			$datain = addslashes($datain);
			$datain = preg_replace('/^\s*$/', "", $datain);
			$datain = preg_replace('/\s*$/', "", $datain);
			// so far so good
			if (!empty($datain)) {
				$array = preg_split("/[\n]+/", $datain);
				$dataout = new StdClass;
				foreach ($array as $object) {
					$handle = null;
					$data = null;
					@list($handle, $data) = explode(":", $object);
					$handle = preg_replace('/^\s*$/', "", $handle);
					$data = preg_replace('/^\s*/', "", $data);
					$data = preg_replace('/\s*$/', "", $data);
					#if (!empty($handle) && array_key_exists($handle, $this->settings->objectentries)) {
					if (!empty($handle) && class_exists($dataout->{$handle}) == true)
						$dataout->{$handle}
					$tmp = new StdClass;
					$tmp[]->value = $data;
					$dataout->{$handle}[]= $tmp;
				}
				return $dataout;
			} else {
				return false;
			}
		} else {
			return false;
		}
	}
}
?>
